variables:
  REGISTRY_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
stages:
  - build
  - test
  - package
  - deploy
gradle-build:
  image: gradle:alpine
  stage: build
  script: gradle bootJar
  artifacts:
    paths:
      - build
      - .gradle
    expire_in: 7 days
test:
  image: gradle:alpine
  stage: test
  script: gradle test
  artifacts:
    paths:
      - build
      - .gradle
    expire_in: 7 days
docker-build:
  image: docker:latest
  stage: package
  services:
    - docker:dind
  script:
    - docker build -t $REGISTRY_IMAGE .
    - docker login -u $CI_REGISTRY_USER -p $CI_BUILD_TOKEN $CI_REGISTRY
    - docker push $REGISTRY_IMAGE

k8s-deploy:
  image: google/cloud-sdk
  stage: deploy
  script:
    - export GOOGLE_APPLICATION_CREDENTIALS=$GCP_KEY
    - export KUBECONFIG=$KUBE_CONF
    - kubectl delete secret registry.gitlab.com -n $KUBE_NAMESPACE
    - kubectl create secret docker-registry $CI_REGISTRY --docker-server=https://registry.gitlab.com --docker-username=$CI_REGISTRY_USER --docker-password=$CI_REGISTRY_PASSWORD -n $KUBE_NAMESPACE
    - kubectl apply -f deployment.yaml -n $KUBE_NAMESPACE
  only:
    - master